import java.lang.*;
import java.io.*;
import java.util.*;
import java.sql.*;
import java.awt.Color;

class graphs {
  menu_swing parent;
  private int lengthOfTask;
  private int current = 0;

  String aQuery;
  String aYear;
  String aMonth;
  String aDay;
  String fromDay;
  String toDay;
  String name;

  String url;
  String driver;
  String user;
  String password;

  private boolean isIllustra = false;
  private boolean isOracle = true;

  public graphs(menu_swing menu) {
    lengthOfTask = 100;
    this.parent = menu;
    setBooleanDB(parent.getWhichDB());
  }

  public void setBooleanDB(String aDB) {
    if (aDB == "Illustra") {
      isIllustra = true;
      isOracle = false;
    }
    else if (aDB == "Oracle") {
      isIllustra = false;
      isOracle = true;
    }
    else {
      System.out.println("Illegal DB selection.");
    }
  }

  public void setDBEnvironment() {
    if (isIllustra) {
      url = "jdbc:mijdbc://sandman.npac.syr.edu:7531/GIS";
      driver = "mijdbc.MIDriver";
      user = "miadmin";
      password = "";
    }
    else if (isOracle) {
      url = "jdbc:oracle:oci7:";
      driver = "oracle.jdbc.driver.OracleDriver";
      user = "deepak";
      password = "deepak";
    }
    else {
      System.out.println("There is a DB selection error.");
    }
  }

  class aDayTask {
    aDayTask () {
      try {
        String	data;
        int	i;
        String query = "";
        String condition, timeCondition;

        Class.forName( driver );      

        Connection conn = 
	  DriverManager.getConnection(url, user, password);
      
        Statement stat = conn.createStatement();

        FileOutputStream s = new FileOutputStream(name + ".sva");
        DataOutput aDO = new DataOutputStream(s);

        data = "1"+"\n"+"\r";
        StringBuffer line = new StringBuffer(data);
        aDO.writeBytes(line.toString());
        data = "1.0"+"\n"+"\r";
        line = new StringBuffer(data);
        aDO.writeBytes(line.toString());

        for (i = 0; i < 24; i++) {

          if (i < 10) {
	    condition = "0"+Integer.toString(i);
          }
	  else {
	    condition = Integer.toString(i);
	  }
          if (isIllustra) {
            query = aQuery + "'" + aDay + " " + condition + ":00:00' and " +
                    "'" + aDay + " " + condition + ":59:59';";
          }
          else if (isOracle) {
            query = aQuery + "to_date('" + aDay + " " + condition + ":00:00', " +
                    "'mon dd yyyy hh24:mi:ss') and " + "to_date('" + aDay + " " +
                    condition + ":59:59', 'mon dd yyyy hh24:mi:ss')";
          }
          else {System.out.println("There is an error in DB selection.");}

          System.out.println("Query: " + query);
          parent.setMessage("Counting " + condition + " hour data.", Color.red);
          current = lengthOfTask * i / 24;
          //parent.setProgressBar(100 * i / 24);
          //parent.bp.barP.pBar.setValue(100 * i / 24);
          System.out.println("Progress-----" + current);
          ResultSet rs = stat.executeQuery(query);

          if ( rs.next() ) {
	    String s1 = rs.getString(1);
            data = Integer.toString(i)+" "+s1+"\n"+"\r";
            line = new StringBuffer(data);
	    System.out.println("Count from a query at "+condition+" is "+s1+".");
            aDO.writeBytes(line.toString());
          }
        }
        s.close();
        conn.close();
        Runtime.getRuntime().exec("java SV " + name + ".sva");
        current = lengthOfTask;
        parent.setMessage("Please see the visualized graph.", Color.blue);
      }
      catch ( Exception e ) {
        System.err.println("Exception: "+e);
        e.printStackTrace();
      }
    }
  }

  class DailyTask {
    DailyTask() {
      try {
        String	data;
        int	i;
        String query = "";
        String condition;

        //this.parent = menu;

        Integer from = new Integer(fromDay);
        Integer to = new Integer(toDay);

        if (from.intValue() > to.intValue() ) {
          System.out.println("Illegal day period input.");
          System.exit(0);
        }

        Class.forName( driver );      

        Connection conn = 
	  DriverManager.getConnection(url, user, password);
      
        Statement stat = conn.createStatement();

        FileOutputStream s = new FileOutputStream(name + ".sva");
        DataOutput aDO = new DataOutputStream(s);

        data = "1"+"\n"+"\r";
        StringBuffer line = new StringBuffer(data);
        aDO.writeBytes(line.toString());
        data = "1.0"+"\n"+"\r";
        line = new StringBuffer(data);
        aDO.writeBytes(line.toString());

        i = from.intValue();
        System.out.println("From: " + from.toString() + " To: " + to.toString());
        for (; i <= to.intValue() ; i++) {

          condition = Integer.toString(i);

          aDay = aMonth + " " + condition + " " + aYear;
          if (isIllustra) {
            query = aQuery + "'" + aDay + " 00:00:00' and " +
                  "'" + aDay + " 23:59:59';";
          }
          else if (isOracle) {
            query = aQuery + "to_date('" + aDay + " 00:00:00', 'mon dd yyyy hh24:mi:ss') " +
                    "and to_date('" + aDay + " 23:59:59', 'mon dd yyyy hh24:mi:ss')";
          }
          else { System.out.println("There is an error in DB selection."); }
                    
          System.out.println("Query: " + query);
	  parent.setMessage("Counting " + condition + " of " + aMonth + " data.", Color.red);

          current = lengthOfTask * (i - from.intValue()) / (to.intValue() - from.intValue());
          System.out.println("Progress-----" + current);

          ResultSet rs = stat.executeQuery(query);

          if ( rs.next() ) {
	    String s1 = rs.getString(1);
            data = Integer.toString(i)+" "+s1+"\n"+"\r";
            line = new StringBuffer(data);
	    System.out.println("Count from a query at "+condition+" is "+s1+".");
            aDO.writeBytes(line.toString());
          }
        }
        s.close();
        conn.close();
        Runtime.getRuntime().exec("java SV " + name + ".sva");
        current = lengthOfTask;
        parent.setMessage("Please see the visualized graph.", Color.blue);
      }
      catch ( Exception e ) {
        System.err.println("Exception: "+e);
        e.printStackTrace();
      }
    }
  }

  void go(String paQuery, String paDay, String pname) {
    aQuery = paQuery;
    aDay = paDay;
    name = pname;
    setDBEnvironment();

    final SwingWorker worker = new SwingWorker() {
      public Object construct() {
        return new aDayTask();
      }
    };
  }

  void go(String paQuery, String pname, String pfromDay, String ptoDay) {
    aQuery = paQuery;
    name = pname;
    fromDay = pfromDay;
    toDay = ptoDay;
    aMonth = parent.aMonth;
    aYear = parent.aYear;

    setDBEnvironment();

    final SwingWorker worker = new SwingWorker() {
      public Object construct() {
        return new DailyTask();
      }
    };
  }

  int getLengthOfTask() {
    return lengthOfTask;
  }

  int getCurrent() {
    return current;
  }

  boolean done() {
    if (current >= lengthOfTask)
      return true;
    else
      return false;
  }
}